from syntax import *
from sign_analysis import eval_aexp, eval_bexp, abstract_env, sign

x: ArithExpr = AEVar("x")
y: ArithExpr = AEVar("y")

# y * (x - x / y)
test_aexp: ArithExpr = AEBop(Bop.MUL,y,AEBop(Bop.ADD,x, AEUop(Uop.OPP,AEBop(Bop.DIV,x,y))))

# ! (x - y <= y * (x - x/y))
test_bexp: BoolExpr = BENeg(BELeq(AEBop(Bop.ADD,x,AEUop(Uop.OPP,y)),test_aexp))

def test(env: abstract_env) -> None:
    res_a = eval_aexp(env,test_aexp)
    res_b = eval_bexp(env,test_bexp)
    print(f'In environment { {var: str(sign) for (var,sign) in env.items()} }')
    print(f"{test_aexp} -> {res_a}")
    print(f"{test_bexp} -> {res_b}")

test({ 'x': sign.SPOS, 'y': sign.SPOS })

test({ 'x': sign.NEG, 'y': sign.NEG })

test({ 'x': sign.INT, 'y': sign.Z })

test({ 'x': sign.POS, 'y': sign.NZ })

test({})
