from syntax import *
from sign_analysis import state, abstract_env, sign, reduce_state

x: ArithExpr = AEVar("x")
y: ArithExpr = AEVar("y")

test_eq: BoolExpr = BEEq(x,y)

test_neq: BoolExpr = BENeg(test_eq)

test_leq: BoolExpr = BELeq(x,y)

test_gt: BoolExpr = BENeg(test_leq)

def test(env: abstract_env) -> None:
    res_eq = reduce_state(env,test_eq)
    res_neq = reduce_state(env,test_neq)
    res_leq = reduce_state(env,test_leq)
    res_gt = reduce_state(env,test_gt)
    print(f'In environment { {var: str(sign) for (var,sign) in env.items()} }')
    print(f"{test_eq} -> {res_eq}")
    print(f"{test_neq} -> {res_neq}")
    print(f"{test_leq} -> {res_leq}")
    print(f"{test_gt} -> {res_gt}")

test({ 'x': sign.POS, 'y': sign.NEG })

test({ 'x': sign.NZ, 'y': sign.NEG })

test({ 'x': sign.POS, 'y': sign.SNEG })

test({ 'x': sign.Z, 'y': sign.POS })

